Index: issm/trunk/src/c/classes/FemModel.cpp
===================================================================
--- issm/trunk/src/c/classes/FemModel.cpp	(revision 23389)
+++ issm/trunk/src/c/classes/FemModel.cpp	(revision 23394)
@@ -17,4 +17,9 @@
 #include "../shared/Enum/Enum.h"
 #include "../analyses/analyses.h"
+
+#if _HAVE_CODIPACK_
+#include <sstream> // for output of the CoDiPack tape
+extern CoDi_global codi_global;
+#endif
 
 /*module includes: {{{*/
@@ -84,11 +89,11 @@
 	this->parameters->FindParam(&amr_frequency,TransientAmrFrequencyEnum);
 	this->parameters->FindParam(&amr_frequency,TransientAmrFrequencyEnum);
-	#if defined(_HAVE_NEOPZ_) && !defined(_HAVE_ADOLC_)
+	#if defined(_HAVE_NEOPZ_) && !defined(_HAVE_AD_)
 	this->amr = NULL;
 	#endif
-	#if defined(_HAVE_BAMG_) && !defined(_HAVE_ADOLC_)
+	#if defined(_HAVE_BAMG_) && !defined(_HAVE_AD_)
 	this->amrbamg = NULL;
 	#endif
-	#if !defined(_HAVE_ADOLC_)
+	#if !defined(_HAVE_AD_)
 	if(amr_frequency && solution_type==TransientSolutionEnum){
 		/*Verifications. AMR supports SSA, P1 and horizontal 2D domain*/
@@ -147,8 +152,8 @@
 	profiler->Stop(MPROCESSOR);
 
-	#if defined(_HAVE_NEOPZ_) && !defined(_HAVE_ADOLC_)
+	#if defined(_HAVE_NEOPZ_) && !defined(_HAVE_AD_)
 	this->amr = NULL;
 	#endif
-	#if defined(_HAVE_BAMG_) && !defined(_HAVE_ADOLC_)
+	#if defined(_HAVE_BAMG_) && !defined(_HAVE_AD_)
 	this->amrbamg = NULL;
 	#endif
@@ -184,9 +189,9 @@
 	if(results)delete results;
 
-	#if defined(_HAVE_NEOPZ_) && !defined(_HAVE_ADOLC_)
+	#if defined(_HAVE_NEOPZ_) && !defined(_HAVE_AD_)
 	if(amr)delete amr;
 	#endif
 
-	#if defined(_HAVE_BAMG_) && !defined(_HAVE_ADOLC_)
+	#if defined(_HAVE_BAMG_) && !defined(_HAVE_AD_)
 	if(amrbamg)delete amrbamg;
 	#endif
@@ -254,8 +259,12 @@
 	/*Before we delete the profiler, report statistics for this run: */
 	profiler->Stop(TOTAL);  //final tagging
+
 	_printf0_("\n");
-	_printf0_("   "<<setw(40)<<left<<"FemModel initialization elapsed time:"<<profiler->TotalTime(MPROCESSOR) << "\n");
-	_printf0_("   "<<setw(40)<<left<<"Core solution elapsed time:"<<profiler->TotalTime(CORE) << "\n");
-	_printf0_("   "<<setw(40)<<left<<"Solver elapsed time:"<<profiler->TotalTime(SOLVER) << "\n");
+	_printf0_("   "<<setw(40)<<left<<"FemModel initialization elapsed time:"<<setw(7)<<profiler->TotalTime(MPROCESSOR) << "\n");
+	/*Total times*/
+	_printf0_("   "<<setw(40)<<left<<"Total Core solution elapsed time:"<<setw(7)<<profiler->TotalTime(CORE) << "\n");
+
+	/*Linear solver only*/
+	_printf0_("   "<<setw(40)<<left<<"Linear solver elapsed time:"<<setw(7)<<profiler->TotalTime(SOLVER) << " ("<<setprecision(2)<<profiler->TotalTime(SOLVER)/profiler->TotalTime(CORE)*100.<<"%)\n");
 	_printf0_("\n");
 	_printf0_("   Total elapsed time: "
@@ -319,8 +328,8 @@
 
 	/*AMR, no copy for now*/
-	#if defined(_HAVE_NEOPZ_) && !defined(_HAVE_ADOLC_)
+	#if defined(_HAVE_NEOPZ_) && !defined(_HAVE_AD_)
 	this->amr = NULL;
 	#endif
-	#if defined(_HAVE_BAMG_) && !defined(_HAVE_ADOLC_)
+	#if defined(_HAVE_BAMG_) && !defined(_HAVE_AD_)
 	this->amrbamg = NULL;
 	#endif
@@ -853,8 +862,23 @@
 		solution_memory=profiler->Memory(CORE);
 
-		_printf0_("Core solution elapsed time    : " << solution_time   << " Seconds\n");
-		_printf0_("Core solution number of flops : " << solution_flops  << " Flops\n");
-		_printf0_("Core solution memory used     : " << solution_memory << " Bytes\n");
-
+		_printf0_("\nCore solution profiling\n");
+		_printf0_("   elapsed time    : " << solution_time   << " Seconds\n");
+		_printf0_("   number of flops : " << solution_flops  << " Flops\n");
+		_printf0_("   memory used     : " << solution_memory << " Bytes\n");
+
+		/*Individual cores*/
+		_printf0_("Individual core profiling\n");
+		if(profiler->Used(THERMALCORE)) _printf0_("   "<<setw(40)<<left<<"Thermal core elapsed time:"<<setw(7)<<setprecision(6)<<profiler->TotalTime(THERMALCORE) << " sec\n");
+		if(profiler->Used(HYDROLOGYCORE)) _printf0_("   "<<setw(40)<<left<<"Hydrology core elapsed time:"<<setw(7)<<setprecision(6)<<profiler->TotalTime(HYDROLOGYCORE) << " sec\n");
+		if(profiler->Used(STRESSBALANCECORE)) _printf0_("   "<<setw(40)<<left<<"Stress balance core elapsed time:"<<setw(7)<<setprecision(6)<<profiler->TotalTime(STRESSBALANCECORE) << " sec\n");
+		if(profiler->Used(DAMAGECORE)) _printf0_("   "<<setw(40)<<left<<"Damage core elapsed time:"<<setw(7)<<setprecision(6)<<profiler->TotalTime(DAMAGECORE) << " sec\n");
+		if(profiler->Used(MOVINGFRONTCORE)) _printf0_("   "<<setw(40)<<left<<"Moving front core elapsed time:"<<setw(7)<<setprecision(6)<<profiler->TotalTime(MOVINGFRONTCORE) << " sec\n");
+		if(profiler->Used(MASSTRANSPORTCORE)) _printf0_("   "<<setw(40)<<left<<"Mass transport core elapsed time:"<<setw(7)<<setprecision(6)<<profiler->TotalTime(MASSTRANSPORTCORE) << " sec\n");
+		if(profiler->Used(SMBCORE)) _printf0_("   "<<setw(40)<<left<<"SMB core elapsed time:"<<setw(7)<<setprecision(6)<<profiler->TotalTime(SMBCORE) << " sec\n");
+		if(profiler->Used(GROUNDINGLINECORE)) _printf0_("   "<<setw(40)<<left<<"Groundingline migration core elapsed time:"<<setw(7)<<setprecision(6)<<profiler->TotalTime(GROUNDINGLINECORE) << " sec\n");
+		if(profiler->Used(GIACORE)) _printf0_("   "<<setw(40)<<left<<"GIA core elapsed time:"<<setw(7)<<setprecision(6)<<profiler->TotalTime(GIACORE) << " sec\n");
+		if(profiler->Used(ESACORE)) _printf0_("   "<<setw(40)<<left<<"ESA core elapsed time:"<<setw(7)<<setprecision(6)<<profiler->TotalTime(ESACORE) << " sec\n");
+		if(profiler->Used(SLRCORE)) _printf0_("   "<<setw(40)<<left<<"SLR core elapsed time:"<<setw(7)<<setprecision(6)<<profiler->TotalTime(SLRCORE) << " sec\n");
+		
 		/*Add to results: */
 		results->AddObject(new GenericExternalResult<IssmDouble>(results->Size()+1, ProfilingSolutionTimeEnum,  solution_time));
@@ -862,13 +886,15 @@
 		results->AddObject(new GenericExternalResult<IssmDouble>(results->Size()+1, ProfilingCurrentFlopsEnum, solution_flops));
 
-		#ifdef _HAVE_ADOLC_
-		solution_time=profiler->TotalTime(ADCORE);
-		solution_flops=profiler->TotalFlops(ADCORE);
-		solution_memory=profiler->Memory(ADCORE);
-
-		_printf0_("AD Solution elapsed time    : " << solution_time   << " Seconds\n");
-		_printf0_("AD Solution number of flops : " << solution_flops  << " Flops\n");
-		_printf0_("AD Solution memory used     : " << solution_memory << " Bytes\n");
+		#ifdef _HAVE_AD_
+		solution_time   = profiler->TotalTime(ADCORE);
+		solution_flops  = profiler->TotalFlops(ADCORE);
+		solution_memory = profiler->Memory(ADCORE);
+
+		_printf0_("AD profiling\n");
+		_printf0_("   elapsed time    : " << solution_time   << " Seconds\n");
+		_printf0_("   number of flops : " << solution_flops  << " Flops\n");
+		_printf0_("   memory used     : " << solution_memory << " Bytes\n");
 		#endif
+		_printf0_("\n");
 
 	}
@@ -1824,9 +1850,13 @@
 
 	if(isautodiff){
-		#ifdef _HAVE_ADOLC_
+		#ifdef _HAVE_AD_
 		parameters->FindParam(&num_dependents,AutodiffNumDependentsEnum);
 		parameters->FindParam(&dependent_objects,AutodiffDependentObjectsEnum);
 		if(num_dependents){
 			dependents=xNew<IssmPDouble>(num_dependents);
+
+			#if defined(_HAVE_CODIPACK_)
+			auto& tape_codi = IssmDouble::getGlobalTape();
+			#endif
 
 			/*Go through our dependent variables, and compute the response:*/
@@ -1835,5 +1865,11 @@
 				dep->Responsex(&output_value,this);
 				if (my_rank==0) {
-					output_value>>=dependents[i];
+					#if defined(_HAVE_CODIPACK_)
+						tape_codi.registerOutput(output_value);
+						dependents[i] = output_value.getValue();
+						codi_global.output_indices.push_back(output_value.getGradientData());
+					#else
+						output_value>>=dependents[i];
+					#endif
 				}
 			}
@@ -2509,5 +2545,5 @@
 
 /*AMR*/
-#if !defined(_HAVE_ADOLC_)
+#ifndef _HAVE_AD_
 void FemModel::ReMesh(void){/*{{{*/
 
@@ -2528,9 +2564,9 @@
 	this->parameters->FindParam(&amrtype,AmrTypeEnum);
 	switch(amrtype){
-		#if defined(_HAVE_NEOPZ_) && !defined(_HAVE_ADOLC_)
+		#if defined(_HAVE_NEOPZ_) && !defined(_HAVE_AD_)
 		case AmrNeopzEnum: this->ReMeshNeopz(&newnumberofvertices,&newnumberofelements,&newx,&newy,&newz,&newelementslist); break;
 								 #endif
 
-		#if defined(_HAVE_BAMG_) && !defined(_HAVE_ADOLC_)
+		#if defined(_HAVE_BAMG_) && !defined(_HAVE_AD_)
 		case AmrBamgEnum: this->ReMeshBamg(&newnumberofvertices,&newnumberofelements,&newx,&newy,&newz,&newelementslist); break;
 		#endif
@@ -4884,5 +4920,5 @@
 #endif
 
-#if defined(_HAVE_BAMG_) && !defined(_HAVE_ADOLC_)
+#if defined(_HAVE_BAMG_) && !defined(_HAVE_AD_)
 void FemModel::ReMeshBamg(int* pnewnumberofvertices,int* pnewnumberofelements,IssmDouble** pnewx,IssmDouble** pnewy,IssmDouble** pnewz,int** pnewelementslist){/*{{{*/
 
@@ -5210,5 +5246,5 @@
 #endif
 
-#if defined(_HAVE_NEOPZ_) && !defined(_HAVE_ADOLC_)
+#if defined(_HAVE_NEOPZ_) && !defined(_HAVE_AD_)
 void FemModel::ReMeshNeopz(int* pnewnumberofvertices,int* pnewnumberofelements,IssmDouble** pnewx,IssmDouble** pnewy,IssmDouble** pnewz,int** pnewelementslist){/*{{{*/
 
Index: issm/trunk/src/c/classes/FemModel.h
===================================================================
--- issm/trunk/src/c/classes/FemModel.h	(revision 23389)
+++ issm/trunk/src/c/classes/FemModel.h	(revision 23394)
@@ -20,8 +20,8 @@
 class Profiler;
 class Elements;
-#if defined(_HAVE_NEOPZ_) && !defined(_HAVE_ADOLC_)
+#if defined(_HAVE_NEOPZ_) && !defined(_HAVE_AD_)
 #include "./AdaptiveMeshRefinement.h"
 #endif
-#if defined(_HAVE_BAMG_) && !defined(_HAVE_ADOLC_)
+#if defined(_HAVE_BAMG_) && !defined(_HAVE_AD_)
 #include "./AmrBamg.h"
 #endif
@@ -51,9 +51,9 @@
 
 		//FIXME: do we want only one class and have virtual functions? or keep 2 classes, at least rename AdaptiveMeshRefinement -> AmrNeopz
-		#if defined(_HAVE_NEOPZ_) && !defined(_HAVE_ADOLC_)
+		#if defined(_HAVE_NEOPZ_) && !defined(_HAVE_AD_)
 		AdaptiveMeshRefinement *amr;		  //adaptive mesh refinement object. It keeps coarse mesh and execute refinement process
 		#endif
 
-		#if defined(_HAVE_BAMG_) && !defined(_HAVE_ADOLC_)
+		#if defined(_HAVE_BAMG_) && !defined(_HAVE_AD_)
 		AmrBamg *amrbamg; //adaptive mesh refinement object. It keeps coarse mesh and execute refinement process
 		#endif
@@ -164,5 +164,5 @@
 
 		/*AMR*/
-		#if !defined(_HAVE_ADOLC_)
+		#if !defined(_HAVE_AD_)
 		void ReMesh(void);
 		void BedrockFromMismipPlus(void);
@@ -191,5 +191,5 @@
 		#endif
 
-		#if defined(_HAVE_BAMG_) && !defined(_HAVE_ADOLC_)
+		#if defined(_HAVE_BAMG_) && !defined(_HAVE_AD_)
 		void ReMeshBamg(int* pnewnumberofvertices,int* pnewnumberofelements,IssmDouble** pnewx,IssmDouble** pnewy,IssmDouble** pnewz,int** pnewelementslist);
 		void InitializeAdaptiveRefinementBamg(void);
@@ -199,5 +199,5 @@
 		#endif
 
-		#if defined(_HAVE_NEOPZ_) && !defined(_HAVE_ADOLC_)
+		#if defined(_HAVE_NEOPZ_) && !defined(_HAVE_AD_)
 		void ReMeshNeopz(int* pnewnumberofvertices,int* pnewnumberofelements,IssmDouble** pnewx,IssmDouble** pnewy,IssmDouble** pnewz,int** pnewelementslist);
 		void InitializeAdaptiveRefinementNeopz(void);
Index: issm/trunk/src/c/classes/IoModel.cpp
===================================================================
--- issm/trunk/src/c/classes/IoModel.cpp	(revision 23389)
+++ issm/trunk/src/c/classes/IoModel.cpp	(revision 23394)
@@ -27,4 +27,9 @@
 #include "../shared/io/io.h"
 #include "../shared/shared.h"
+
+#ifdef _HAVE_CODIPACK_
+extern CoDi_global codi_global;
+#include <sstream> // for output of the CoDiPack tape
+#endif
 
 /*IoConstant class and methods*/
@@ -431,5 +436,6 @@
 	if(trace || (autodiff && !iscontrol)){
 
-		#ifdef _HAVE_ADOLC_
+		#ifdef _HAVE_AD_
+		// FIXME codi here we should be able to execute codi version as normal
 		this->FetchData(&num_independent_objects,"md.autodiff.num_independent_objects");
 		if(num_independent_objects){
@@ -460,5 +466,5 @@
 		#else
 		/*if we asked for AD computations, we have a problem!: */
-		_error_("Cannot carry out AD mode computations without support of ADOLC compiled in!");
+		_error_("Cannot carry out AD mode computations without support of ADOLC or CoDiPack compiled in!");
 		#endif
 	}
@@ -1702,5 +1708,5 @@
 	if(X) Xcount=*pXcount;
 
-	#ifdef _HAVE_ADOLC_ //cannot come here unless you are running AD mode, from DeclaredIndependents:
+	#ifdef _HAVE_AD_ //cannot come here unless you are running AD mode, from DeclaredIndependents:
 
 	/*output: */
@@ -1719,10 +1725,22 @@
 		/*Now, before we even broadcast this to other nodes, declare the scalar  as an independent variable!. If we 
 		 *have been supplied an X vector, use it instead of what we just read: */
-		if(X){
-			scalar<<=X[Xcount];
-		}
-		else{
-			scalar<<=pscalar;
-		}
+		#if defined(_HAVE_CODIPACK_)
+			// FIXME codi here we just assign instead of using "operator <<="
+			if(X){
+				scalar=X[Xcount];
+			} else {
+				scalar=pscalar;
+			}
+			auto& tape_codi = IssmDouble::getGlobalTape();
+			tape_codi.registerInput(scalar);
+			codi_global.input_indices.push_back(scalar.getGradientData());
+		#else
+			if(X){
+				scalar<<=X[Xcount];
+			}
+			else{
+				scalar<<=pscalar;
+			}
+		#endif
 	}
 
@@ -1744,5 +1762,5 @@
 	if(X) Xcount=*pXcount;
 
-	#ifdef _HAVE_ADOLC_ //cannot come here unless you are running AD mode, from DeclaredIndependents:
+	#ifdef _HAVE_AD_ //cannot come here unless you are running AD mode, from DeclaredIndependents:
 
 	/*Intermediaries*/
@@ -1785,10 +1803,29 @@
 			/*Now, before we even broadcast this to other nodes, declare the whole matrix as a independent variable!
 			  If we have been supplied an X vector, use it instead of what we just read: */
-			if(X){
-				for(int i=0;i<M*N;i++) matrix[i]<<=X[Xcount+i];  /*<<= ADOLC overloaded operator to declare independent*/
-			}
-			else{
-				for(int i=0;i<M*N;i++) matrix[i]<<=buffer[i];
-			}
+			#if defined(_HAVE_CODIPACK_)
+				// FIXME codi here we just assign instead of using "operator <<="
+				auto& tape_codi = IssmDouble::getGlobalTape();
+				if(X){
+					for (int i=0;i<M*N;i++) {
+						matrix[i]=X[Xcount+i];
+						tape_codi.registerInput(matrix[i]);
+						codi_global.input_indices.push_back(matrix[i].getGradientData());
+					}
+				}
+				else{
+					for (int i=0;i<M*N;i++) {
+						matrix[i]=buffer[i];
+						tape_codi.registerInput(matrix[i]);
+						codi_global.input_indices.push_back(matrix[i].getGradientData());
+					}
+				}
+			#else /*ADOLC*/
+				if(X){
+					for(int i=0;i<M*N;i++) matrix[i]<<=X[Xcount+i];  /*<<= ADOLC overloaded operator to declare independent*/
+				}
+				else{
+					for(int i=0;i<M*N;i++) matrix[i]<<=buffer[i];
+				}
+			#endif
 		}
 		ISSM_MPI_Bcast(matrix,M*N,ISSM_MPI_DOUBLE,0,IssmComm::GetComm()); 
@@ -1798,4 +1835,6 @@
 	else _error_("cannot declare the independent variable \"" << data_name <<  "\" if it's empty!");
 
+	// FIXME codi is that at all relevant to CoDiPack or can we simply assume the same?
+	
 	/*Add to data as independent*/
 	this->AddDataIndependent(new IoData(matrix,code,layout,M,N,data_name));
@@ -2472,5 +2511,7 @@
 	/*recover my_rank:*/
 	my_rank=IssmComm::GetRank();
-	_assert_(strncmp(data_name,mddot,3)==0);
+	if(strncmp(data_name,mddot,3)!=0){
+		_error_("Cannot fetch \""<<data_name<<"\" does not start with \""<<mddot<<"\"");
+	}
 
 	/*Go find in the binary file, the position of the data we want to fetch: */
@@ -2562,5 +2603,6 @@
 
 	if(trace || (autodiff && !iscontrol)){
-		#ifdef _HAVE_ADOLC_
+
+		#if defined(_HAVE_ADOLC_)
 		/*Retrieve parameters: */
 		this->FetchData(&keep,"md.autodiff.keep");
@@ -2579,7 +2621,35 @@
 		int skipFileDeletion=1;
 		trace_on(my_rank,keepTaylors,reCast<size_t>(obufsize),reCast<size_t>(lbufsize),reCast<size_t>(cbufsize),reCast<size_t>(tbufsize),skipFileDeletion);
+
+		#elif defined(_HAVE_CODIPACK_)
+		//fprintf(stderr, "*** Codipack IoModel::StartTrace\n");
+		/*
+		 * FIXME codi
+		 * - ADOL-C variant uses fine grained tracing with various arguments
+		 * - ADOL-C variant sets a garbage collection parameter for its tape
+		 * -> These parameters are not read for the CoDiPack ISSM version!
+		 */
+		auto& tape_codi = IssmDouble::getGlobalTape();
+		tape_codi.setActive();
+		#if _AD_TAPE_ALLOC_
+		//alloc_profiler.Tag(StartInit, true);
+		IssmDouble x_t(1.0), y_t(1.0);
+		tape_codi.registerInput(y_t);
+		int codi_allocn = 0;
+		this->FetchData(&codi_allocn,"md.autodiff.tapeAlloc");
+		for(int i = 0;i < codi_allocn;++i) {
+			x_t = y_t * y_t;
+		}
+		/*
+		std::stringstream out_s;
+		IssmDouble::getGlobalTape().printStatistics(out_s);
+		_printf0_("StartTrace::Tape Statistics	   : TapeAlloc count=[" << codi_allocn << "]\n" << out_s.str());
+		*/
+		tape_codi.reset();
+		//alloc_profiler.Tag(FinishInit, true);
 		#endif
-	}
-
-}
-/*}}}*/
+		#endif
+	}
+
+}
+/*}}}*/
Index: issm/trunk/src/c/classes/Materials/Matpar.cpp
===================================================================
--- issm/trunk/src/c/classes/Materials/Matpar.cpp	(revision 23389)
+++ issm/trunk/src/c/classes/Materials/Matpar.cpp	(revision 23394)
@@ -107,9 +107,13 @@
 					iomodel->FindConstant(&this->rlapslgm,"md.smb.rlapslgm");
 					break;
+				case SMBpddSicopolisEnum:
+					iomodel->FindConstant(&this->desfac,"md.smb.desfac");
+					iomodel->FindConstant(&this->rlaps,"md.smb.rlaps");
+					break;
 				case SMBd18opddEnum:
 					iomodel->FindConstant(&this->desfac,"md.smb.desfac");
 					iomodel->FindConstant(&this->rlaps,"md.smb.rlaps");
 					iomodel->FindConstant(&this->rlapslgm,"md.smb.rlapslgm");
-					iomodel->FindConstant(&this->dpermil,"md.smb.dpermil");					
+					iomodel->FindConstant(&this->dpermil,"md.smb.dpermil");
 				case SMBgradientsEnum:
 					/*Nothing to add*/
@@ -125,4 +129,7 @@
 					break;
 				case SMBmeltcomponentsEnum:
+					/*Nothing to add*/
+					break;
+				case SMBgradientscomponentsEnum:
 					/*Nothing to add*/
 					break;
@@ -170,9 +177,9 @@
 			break;
 		case MaterialsEnum:
-			//we have several types of materials. Retrieve this info first: 
+			//we have several types of materials. Retrieve this info first:
 			iomodel->FetchData(&nature,&nnat,&dummy,"md.materials.nature");
 
-			//go through list of materials, and create constant parameters accordingly: 
-			for(int i=0;i<nnat;i++){ 
+			//go through list of materials, and create constant parameters accordingly:
+			for(int i=0;i<nnat;i++){
 				switch(IoCodeToEnumMaterials(nature[i])){ //{{{
 					case MatlithoEnum:
@@ -211,9 +218,13 @@
 								iomodel->FindConstant(&this->rlapslgm,"md.smb.rlapslgm");
 								break;
+							case SMBpddSicopolisEnum:
+								iomodel->FindConstant(&this->desfac,"md.smb.desfac");
+								iomodel->FindConstant(&this->rlaps,"md.smb.rlaps");
+								break;
 							case SMBd18opddEnum:
 								iomodel->FindConstant(&this->desfac,"md.smb.desfac");
 								iomodel->FindConstant(&this->rlaps,"md.smb.rlaps");
 								iomodel->FindConstant(&this->rlapslgm,"md.smb.rlapslgm");
-								iomodel->FindConstant(&this->dpermil,"md.smb.dpermil");					
+								iomodel->FindConstant(&this->dpermil,"md.smb.dpermil");
 							case SMBgradientsEnum:
 								/*Nothing to add*/
@@ -233,5 +244,5 @@
 							default:
 								_error_("Surface mass balance model "<<EnumToStringx(smb_model)<<" not supported yet");
-						} 
+						}
 						if(hydrology_model==HydrologydcEnum){
 							iomodel->FindConstant(&this->sediment_compressibility,"md.hydrology.sediment_compressibility");
@@ -350,5 +361,5 @@
 
 	this->Echo();
-}		
+}
 /*}}}*/
 void Matpar::Echo(void){/*{{{*/
@@ -381,16 +392,16 @@
 	_printf_("   sediment_porosity: " << sediment_porosity << "\n");
 	_printf_("   sediment_thickness: " << sediment_thickness << "\n");
-	_printf_("   water_compressibility: " << water_compressibility << "\n");	
-	_printf_("   epl_compressibility: " << epl_compressibility << "\n");	
-	_printf_("   epl_porosity: " << epl_porosity << "\n");	
-	_printf_("   epl_init_thickness: " << epl_init_thickness << "\n");	
-	_printf_("   epl_colapse_thickness: " << epl_colapse_thickness << "\n");	
-	_printf_("   epl_max_thickness: " << epl_max_thickness << "\n");	
-	_printf_("   epl_conductivity: " << epl_conductivity << "\n");	
-	_printf_("   lithosphere_shear_modulus: " << lithosphere_shear_modulus << "\n");	
-	_printf_("   lithosphere_density: " << lithosphere_density << "\n");	
-	_printf_("   mantle_shear_modulus: " << mantle_shear_modulus << "\n");	
-	_printf_("   mantle_density: " << mantle_density << "\n");	
-	_printf_("   earth_density: " << earth_density << "\n");	
+	_printf_("   water_compressibility: " << water_compressibility << "\n");
+	_printf_("   epl_compressibility: " << epl_compressibility << "\n");
+	_printf_("   epl_porosity: " << epl_porosity << "\n");
+	_printf_("   epl_init_thickness: " << epl_init_thickness << "\n");
+	_printf_("   epl_colapse_thickness: " << epl_colapse_thickness << "\n");
+	_printf_("   epl_max_thickness: " << epl_max_thickness << "\n");
+	_printf_("   epl_conductivity: " << epl_conductivity << "\n");
+	_printf_("   lithosphere_shear_modulus: " << lithosphere_shear_modulus << "\n");
+	_printf_("   lithosphere_density: " << lithosphere_density << "\n");
+	_printf_("   mantle_shear_modulus: " << mantle_shear_modulus << "\n");
+	_printf_("   mantle_density: " << mantle_density << "\n");
+	_printf_("   earth_density: " << earth_density << "\n");
 	return;
 }
@@ -512,5 +523,5 @@
 			this->dpermil=constant;
 			break;
-		default: 
+		default:
 			break;
 	}
Index: issm/trunk/src/c/classes/Numberedcostfunction.cpp
===================================================================
--- issm/trunk/src/c/classes/Numberedcostfunction.cpp	(revision 23389)
+++ issm/trunk/src/c/classes/Numberedcostfunction.cpp	(revision 23394)
@@ -149,6 +149,8 @@
 				 _error_("not supported");
 		 }
+		 _printf0_("#"<<i+1<<": "<<value<<" ");
 		 value_sum += value;
  }
+	 _printf0_("\n");
 
 	 /*done:*/
Index: issm/trunk/src/c/classes/Options/GenericOption.h
===================================================================
--- issm/trunk/src/c/classes/Options/GenericOption.h	(revision 23389)
+++ issm/trunk/src/c/classes/Options/GenericOption.h	(revision 23394)
@@ -102,5 +102,5 @@
 };
 
-#if defined(_HAVE_ADOLC_) && !defined(_WRAPPERS_) 
+#if defined(_HAVE_AD_) && !defined(_WRAPPERS_) 
 /*We hook off this specific specialization when not running ADOLC, otherwise we get a redeclaration with the next specialization*/
 template <> inline void GenericOption<IssmPDouble*>::Get(IssmPDouble** pvalue){ /*{{{*/
Index: issm/trunk/src/c/classes/Params/Parameters.cpp
===================================================================
--- issm/trunk/src/c/classes/Params/Parameters.cpp	(revision 23389)
+++ issm/trunk/src/c/classes/Params/Parameters.cpp	(revision 23394)
@@ -92,5 +92,5 @@
 }
 /*}}}*/
-void Parameters::DeepEcho(void){/*{{{*/	
+void Parameters::DeepEcho(void){/*{{{*/
 	for(int i=0;i<NUMPARAMS;i++) {
 		if(this->params[i]) this->params[i]->DeepEcho();
@@ -99,5 +99,5 @@
 }
 /*}}}*/
-void Parameters::Echo(void){/*{{{*/	
+void Parameters::Echo(void){/*{{{*/
 	for(int i=0;i<NUMPARAMS;i++) {
 		if(this->params[i]) this->params[i]->Echo();
@@ -139,5 +139,5 @@
 
 			/*Recover enum of object first: */
-			MARSHALLING(obj_enum); 
+			MARSHALLING(obj_enum);
 
 			if(obj_enum==DoubleParamEnum){
@@ -200,5 +200,5 @@
 				fileparam->Marshall(pmarshalled_data,pmarshalled_data_size,marshall_direction);
 				delete fileparam;
-				/* No need to add this object, the pointer is not valid             
+				/* No need to add this object, the pointer is not valid
 					The FemModel should reset all FileParams in the restart function */
 			}
@@ -426,4 +426,40 @@
 }
 /*}}}*/
+void Parameters::FindParamAndMakePassive(IssmPDouble* pscalar,int param_enum){ _assert_(this);/*{{{*/
+	_assert_(param_enum>ParametersSTARTEnum);
+	_assert_(param_enum<ParametersENDEnum);
+
+	/*Get "active" parameter*/
+	IssmDouble intermediary;
+	int index = param_enum - ParametersSTARTEnum -1;
+	if(!this->params[index]) _error_("Parameter " << EnumToStringx(param_enum) <<" not set");
+	this->params[index]->GetParameterValue(&intermediary);
+
+	/*cast to "passive"*/
+	*pscalar=reCast<IssmPDouble>(intermediary);
+}
+/*}}}*/
+void Parameters::FindParamAndMakePassive(IssmPDouble** pvec,int* pM, int param_enum){ _assert_(this);/*{{{*/
+
+	_assert_(param_enum>ParametersSTARTEnum);
+	_assert_(param_enum<ParametersENDEnum);
+
+	int index = param_enum - ParametersSTARTEnum -1;
+
+	/*Output*/
+	int         n;
+	IssmDouble* vector = NULL;
+
+	if(!this->params[index]) _error_("Parameter " << EnumToStringx(param_enum) <<" not set");
+	this->params[index]->GetParameterValue(&vector,&n);
+
+	/*Make output passive*/
+	IssmPDouble* output = xNew<IssmPDouble>(n);
+	for(int i=0;i<n;i++) output[i] = reCast<IssmPDouble>(vector[i]);
+
+	/*assign output pointers*/
+	if(pvec) *pvec = output;
+	if(pM)   *pM   = n;
+}/*}}}*/
 void Parameters::FindParamInDataset(IssmDouble** pIssmDoublearray,int* pM,int* pN,int dataset_type,int enum_type){/*{{{*/
 	_assert_(this);
@@ -613,5 +649,5 @@
 char* OptionsFromAnalysis(char** pouttoolkit,Parameters* parameters,int analysis_type){ /*{{{*/
 
-	/* figure out ISSM options for current analysis, return a string. */ 
+	/* figure out ISSM options for current analysis, return a string. */
 
 	/*output: */
@@ -631,6 +667,6 @@
 
 	parameters->FindParam(&strings,&numanalyses,ToolkitsOptionsStringsEnum);
-	parameters->FindParam(&toolkits,&dummy,ToolkitsTypesEnum); _assert_(dummy==numanalyses); 
-	parameters->FindParam(&analyses,&dummy,ToolkitsOptionsAnalysesEnum); _assert_(dummy==numanalyses); 
+	parameters->FindParam(&toolkits,&dummy,ToolkitsTypesEnum); _assert_(dummy==numanalyses);
+	parameters->FindParam(&analyses,&dummy,ToolkitsOptionsAnalysesEnum); _assert_(dummy==numanalyses);
 
 	if(numanalyses==0)return NULL; //we did not find petsc options, don't bother.
@@ -674,14 +710,14 @@
 	xDelete<int>(analyses);
 	return outstring;
-} 
+}
 /*}}}*/
 void ToolkitsOptionsFromAnalysis(Parameters* parameters,int analysis_type){ /*{{{*/
 
 	/*!\file:  ToolkitsOptionsFromAnalysis.cpp
-	 * \brief: for each analysis, setup the issmoptions string. 
-	 * This is mainly for the case where we run our toolkits using petsc. In this case, we need to 
-	 * plug our toolkits options directly into the petsc options database. This is the case for each analysis type 
+	 * \brief: for each analysis, setup the issmoptions string.
+	 * This is mainly for the case where we run our toolkits using petsc. In this case, we need to
+	 * plug our toolkits options directly into the petsc options database. This is the case for each analysis type
 	 * and parameters
-	 */ 
+	 */
 
 	char* options = NULL;
@@ -695,5 +731,5 @@
 
 	#ifdef _HAVE_PETSC_
-		/*In case we are using PETSC, we do not rely on issmoptions. Instead, we dump issmoptions into the Petsc 
+		/*In case we are using PETSC, we do not rely on issmoptions. Instead, we dump issmoptions into the Petsc
 		 * options database: */
 		#if (_PETSC_MINOR_>=7)
@@ -717,20 +753,2 @@
 }
 /*}}}*/
-
-/*Specific case with ADOL-C, we might need to get double params for m1qn3*/
-#if defined(_HAVE_ADOLC_) && !defined(_WRAPPERS_) 
-void Parameters::FindParamAndMakePassive(double* pscalar,int param_enum){ _assert_(this);/*{{{*/
-	_assert_(param_enum>ParametersSTARTEnum);
-	_assert_(param_enum<ParametersENDEnum);
-
-	/*Get "active" parameter*/
-	IssmDouble intermediary;
-	int index = param_enum - ParametersSTARTEnum -1;
-	if(!this->params[index]) _error_("Parameter " << EnumToStringx(param_enum) <<" not set");
-	this->params[index]->GetParameterValue(&intermediary);
-
-	/*cast to "passive"*/
-	*pscalar=reCast<double>(intermediary);
-}
-/*}}}*/
-#endif
Index: issm/trunk/src/c/classes/Params/Parameters.h
===================================================================
--- issm/trunk/src/c/classes/Params/Parameters.h	(revision 23389)
+++ issm/trunk/src/c/classes/Params/Parameters.h	(revision 23394)
@@ -52,4 +52,6 @@
 		void  FindParam(FILE** pfid,int enum_type);
 		void  FindParam(DataSet** pdataset, int enum_type);
+		void  FindParamAndMakePassive(IssmPDouble* pscalar, int enum_type);
+		void  FindParamAndMakePassive(IssmPDouble** pvec,int* pM,int enum_type);
 		void  FindParamInDataset(IssmDouble** pIssmDoublearray,int* pM,int* pN,int dataset_type,int enum_type);
 
@@ -70,9 +72,4 @@
 		Param* FindParamObject(int enum_type);
 
-		/*Specific instantiations for IssmDouble*: */
-		#if defined(_HAVE_ADOLC_) && !defined(_WRAPPERS_) 
-		void  FindParamAndMakePassive(double* pscalar, int enum_type);
-		#endif
-
 };
 
Index: issm/trunk/src/c/classes/Profiler.cpp
===================================================================
--- issm/trunk/src/c/classes/Profiler.cpp	(revision 23389)
+++ issm/trunk/src/c/classes/Profiler.cpp	(revision 23394)
@@ -15,5 +15,5 @@
 /*Profiler constructors and destructors:*/
 Profiler::Profiler(){/*{{{*/
-	for(int i=0;i<MAXIMUMSIZE;i++){
+	for(int i=0;i<MAXPROFSIZE;i++){
 		this->time[i]          = 0.;
 		this->time_start[i]    = 0.;
@@ -23,4 +23,5 @@
 		this->memory_start[i]  = 0.;
 		this->running[i]       = false;
+		this->used[i]          = false;
 	}
 } /*}}}*/
@@ -32,5 +33,5 @@
 	Profiler* output=new Profiler();
 
-	for(int i=0;i<MAXIMUMSIZE;i++){
+	for(int i=0;i<MAXPROFSIZE;i++){
 		output->time[i]  =this->time[i];
 		output->flops[i] =this->flops[i];
@@ -49,5 +50,5 @@
 
 	_printf_("Profiler:\n");
-	for(int i=0;i<MAXIMUMSIZE;i++){
+	for(int i=0;i<MAXPROFSIZE;i++){
 		_printf_("    Tag "<<i<<":\n");
 		_printf_("       flops:   "<<this->flops[i]<<"\n");
@@ -70,11 +71,11 @@
 	MARSHALLING_ENUM(ProfilerEnum);
 	pointer = &this->time[0];
-	MARSHALLING_DYNAMIC(pointer,IssmPDouble,MAXIMUMSIZE);
+	MARSHALLING_DYNAMIC(pointer,IssmPDouble,MAXPROFSIZE);
 	pointer = &this->flops[0];
-	MARSHALLING_DYNAMIC(pointer,IssmPDouble,MAXIMUMSIZE);
+	MARSHALLING_DYNAMIC(pointer,IssmPDouble,MAXPROFSIZE);
 	pointer = &this->memory[0];
-	MARSHALLING_DYNAMIC(pointer,IssmPDouble,MAXIMUMSIZE);
+	MARSHALLING_DYNAMIC(pointer,IssmPDouble,MAXPROFSIZE);
 	bpointer = &this->running[0];
-	MARSHALLING_DYNAMIC(bpointer,bool,MAXIMUMSIZE);
+	MARSHALLING_DYNAMIC(bpointer,bool,MAXPROFSIZE);
 
 } /*}}}*/
@@ -88,5 +89,5 @@
 	/*Get tag*/
 	_assert_(tag>=0); 
-	_assert_(tag<MAXIMUMSIZE); 
+	_assert_(tag<MAXPROFSIZE); 
 	if(this->running[tag]) _error_("Tag "<<tag<<" has not been stopped");
 
@@ -97,5 +98,5 @@
 	/*Get tag*/
 	_assert_(tag>=0); 
-	_assert_(tag<MAXIMUMSIZE); 
+	_assert_(tag<MAXPROFSIZE); 
 	if(this->running[tag]) _error_("Tag "<<tag<<" has not been stopped");
 
@@ -130,5 +131,5 @@
 	/*Get initial flops*/
 	_assert_(tag>=0); 
-	_assert_(tag<MAXIMUMSIZE); 
+	_assert_(tag<MAXPROFSIZE); 
 	if(this->running[tag]) _error_("Tag "<<tag<<" has not been stopped");
 
@@ -140,5 +141,5 @@
 	/*Check tag*/
 	_assert_(tag>=0); 
-	_assert_(tag<MAXIMUMSIZE); 
+	_assert_(tag<MAXPROFSIZE); 
 	if(this->running[tag]) _error_("Tag "<<tag<<" is already running");
 
@@ -167,5 +168,5 @@
 	/*Plug into this->time: */
 	_assert_(tag>=0); 
-	_assert_(tag<MAXIMUMSIZE); 
+	_assert_(tag<MAXPROFSIZE); 
 	this->time_start[tag]   = t;
 	this->flops_start[tag]  = f;
@@ -174,4 +175,5 @@
 	/*turn on running*/
 	this->running[tag] = true;
+	this->used[tag]    = true;
 }/*}}}*/
 void  Profiler::Stop(int tag,bool dontmpisync){/*{{{*/
@@ -179,5 +181,5 @@
 	/*Check tag*/
 	_assert_(tag>=0); 
-	_assert_(tag<MAXIMUMSIZE); 
+	_assert_(tag<MAXPROFSIZE); 
 	if(!this->running[tag]) _error_("Tag "<<tag<<" is not running");
 
@@ -206,5 +208,5 @@
 	/*Plug into this->time: */
 	_assert_(tag>=0); 
-	_assert_(tag<MAXIMUMSIZE); 
+	_assert_(tag<MAXPROFSIZE); 
 	this->time[tag]   += t - this->time_start[tag];
 	this->flops[tag]  += f - this->flops_start[tag];
@@ -214,2 +216,9 @@
 	this->running[tag] = false;
 }/*}}}*/
+bool  Profiler::Used(int tag){/*{{{*/
+
+	/*Check tag*/
+	_assert_(tag>=0); 
+	_assert_(tag<MAXPROFSIZE); 
+	return this->used[tag];
+}/*}}}*/
